import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.faces.FacesException;
import javax.faces.context.ExceptionHandler;
import javax.faces.context.ExceptionHandlerWrapper;
import javax.faces.context.FacesContext;
import javax.faces.event.ExceptionQueuedEvent;
import javax.faces.event.ExceptionQueuedEventContext;

public class MyCustomExceptionHandler extends ExceptionHandlerWrapper {
  private ExceptionHandler wrapped;
 
  
  public MyCustomExceptionHandler(ExceptionHandler wrapped) {
    this.wrapped = wrapped;
  }
  
  @Override
  public ExceptionHandler getWrapped() {
  	return this.wrapped;
  }


  @Override
  public void handle() throws FacesException {
    Iterator<ExceptionQueuedEvent> iterator = getUnhandledExceptionQueuedEvents().iterator();
    
    while (iterator.hasNext()) {
      ExceptionQueuedEvent event = (ExceptionQueuedEvent) iterator.next();
      ExceptionQueuedEventContext context = (ExceptionQueuedEventContext)event.getSource();
      Throwable throwable = context.getException();
      
      FacesContext fc = FacesContext.getCurrentInstance();
      final Map<String, Object> requestMap = fc.getExternalContext().getRequestMap();      
      try {      
    	  requestMap.put("exceptionMessage", throwable.getMessage());
    	  
    	  List<Throwable> throwables = new ArrayList<>();
    	  Throwable t = throwable.getCause();
    	  while(t != null) {
    		  throwables.add(t);
    		  t = t.getCause();
    	  }
    	  
    	  requestMap.put("exceptionStackTraces", throwables);
    	  
          fc.getApplication().getNavigationHandler().handleNavigation(fc, null, "/error.xhtml");          
          fc.renderResponse();
      } finally {
          iterator.remove();
      }
    }
    this.wrapped.handle();
  }

}